#Include "hmg.ch"

Function  My_SQL_Login() 

DEFINE WINDOW Form_0 ;
  AT 0,0 ;
  WIDTH 280 HEIGHT 200 ;
  TITLE 'Login MySql' ;
  NOSYSMENU ;
  FONT "Arial" SIZE 10
                                                   
  @ 24,30 LABEL Label_HostName ;
    VALUE "HostName/IP" ;
    WIDTH 150 ;
    HEIGHT 35 ;
    BOLD

  @ 59,30 LABEL Label_User ;
    VALUE "User" ;
    WIDTH 120 ;
    HEIGHT 35 ;
    BOLD

  @ 94,30 LABEL Label_Password ;
    VALUE "Password" ;
    WIDTH 120 ;
    HEIGHT 35 ;
    BOLD

  @ 20,120 TEXTBOX p_HostName ;
    HEIGHT 25 ;      
    VALUE cHostName ;                                      
    WIDTH 120 ;			
    ON ENTER iif( !Empty(Form_0.p_HostName.Value),  Form_0.p_User.SetFocus, Form_0.p_HostName.SetFocus )

  @ 55,120 TEXTBOX  p_User ;
    HEIGHT 25 ;
    VALUE cUser ;
    WIDTH 120 ;
    ON ENTER iif( !Empty(Form_0.p_User.Value), Form_0.p_Password.SetFocus, Form_0.p_user.SetFocus  )
									
  @ 90,120 TEXTBOX  p_Password ;
    VALUE cPassWord ;
    PASSWORD ;
    ON ENTER Form_0.Bt_Login.SetFocus

  @ 130,30 BUTTON Bt_Login ;
    CAPTION '&Login' ;
    ACTION My_SQL_Connect( Form_0.p_HostName.Value, Form_0.p_User.Value, Form_0.p_Password.Value  )

  @ 130,143 BUTTON Bt_Logoff ;
    CAPTION '&Cancel' ;
    ACTION Form_0.Release

END WINDOW

CENTER WINDOW Form_0
ACTIVATE WINDOW Form_0

Return Nil
* --------------------------------------------------------------*
Function  My_SQL_Connect( _host, _user, _pass)                            

   If oServer != Nil
      Return Nil
   Endif

   oServer := TMySQLServer():New(_host, _user, _pass )
   
   If oServer:NetErr() 
      MsGInfo("Error connecting to SQL server: " + oServer:Error() )
      Release Window ALL
      Quit
   Endif 

Return Nil 
* --------------------------------------------------------------*
Function My_SQL_DB_Connect( _Database )

   Local i:= 0
   Local aDatabaseList:= {}                                           

   cDatabase:= Lower(_Database)
   If oServer == Nil 
      MsgInfo("Not connected to SQL server!")
      Return Nil
   EndIf

   aDatabaseList:= oServer:ListDBs()
   If oServer:NetErr() 
      MsGInfo("Error verifying database list: " + oServer:Error())
      Release Window ALL
      Quit
   Endif 

   If AScan( aDatabaseList, Lower(_Database) ) == 0
      MsgINFO( "Database " + _Database + " doesn't exist!")
      Return Nil
   EndIf 

   oServer:SelectDB( _Database )
   If oServer:NetErr() 
      MsGInfo("Error connecting to database " + _Database + ": "+oServer:Error() )
      Release Window ALL
      Quit
   Endif 

Return Nil
* --------------------------------------------------------------*
Function My_SQL_Logout()                              

   if oServer != Nil                     
      oServer:Destroy()
      oServer := Nil
   EndIf

Return Nil
* --------------------------------------------------------------*
Function GetColValue( xObj, xForm, nCol)

   Local nPos:= GetProperty(xForm, xObj, 'Value')
   Local aRet:= GetProperty(xForm, xObj, 'Item', nPos)

Return aRet[nCol] 
* --------------------------------------------------------------*
Function DToMy( xDate )

   Local cYear:= alltrim(str(  year( xDate )))
   Local cMon := alltrim(str( month( xDate )))
   Local cDay := alltrim(str(   day( xDate )))
  
Return "'" + cYear + "-" + cMon + "-" + cDay + "'"
* --------------------------------------------------------------*
FUNCTION My_Lov_Func( _ptable, _pfld1, _pfld2, _pwhere, _porder )

   PRIVATE _Retval:='0'
   PRIVATE _table, _fld1, _fld2, _where, _order

   _table := _ptable
   _fld1 := _pfld1
   _fld2 := _pfld2
   _where := _pwhere
   _order := _porder

   if empty(_pwhere)
      _where := '%'
   endif

   DEFINE WINDOW Lov_Form_my ; 
      AT 0,0 ; 
      WIDTH 500 ; 
      HEIGHT 300 ; 
      TITLE "List of Value" ; 
      MODAL  

      @  10, 10 LABEL L1 ; 
         WIDTH 80 ; 
         HEIGHT 20 ; 
         VALUE "Search string:" 

      @  10, 100 Textbox WhatToSearch ; 
         WIDTH 95 ; 
         HEIGHT 20 ; 
         VALUE "%" UPPERCASE
                  
      @  10, 200 BUTTON go ; 
         CAPTION "OK" ; 
         ACTION LoadSearch(2) ; 
         WIDTH 50 ; 
         HEIGHT 20 

      @  40,20 GRID Lov_Grid_my ; 
         WIDTH 450 ; 
         HEIGHT 200 ; 
         HEADERS { "Key", "Name" } ; 
         WIDTHS { 100, 300 } ; 
         VALUE 1 ; 
         ON DBLCLICK select_row_fns() 
                  
   END WINDOW 

   LoadSearch(1) 
  
   CENTER WINDOW Lov_Form_my
   ACTIVATE WINDOW Lov_Form_my

RETURN _Retval 
*:***********************************************
FUNCTION select_row_fns()

   _Retval := GetColValue("Lov_Grid_my", "Lov_Form_my", 1 )
   Lov_Form_my.Release 

RETURN _RetVal
*:**************************************
FUNCTION LoadSearch( _pp )

LOCAL i:=0, oRow:={}, oQuery:=""

DELETE ITEM ALL FROM Lov_Grid_my of Lov_Form_my

if _pp = 2
   _where := rtrim(Lov_Form_my.WhatToSearch.Value) 
endif

_sql := "SELECT " + _fld1 + ', ' + _fld2 + ' FROM ' + _table 
if !empty( _where)
   _sql := _sql + ' WHERE ' + _fld2 + ' LIKE ' + chr(39) + _where + chr(39)
endif

if !empty( _order )
   _sql := _sql + ' ORDER BY ' + _order
else
   _sql := _sql + ' ORDER BY ' + _fld2 
endif

*Lov_Form_my.dSelect.Value := _sql

oQuery := oServer:Query( _sql ) 

If oQuery:NetErr() 
   MsgInfo("SQL SELECT error: " + oQuery:Error())
   RELEASE WINDOW ALL 
   Quit 
Endif 

_redova := oQuery:LastRec()

if _redova = 0
   msginfo('Nema podataka !')
   RELEASE WINDOW ALL 
   Quit 
endif

For i := 1 to oQuery:LastRec() 
   oRow := oQuery:GetRow(i) 
   ADD ITEM { str(oRow:fieldGet(1)), oRow:fieldGet(2) } TO Lov_Grid_my Of Lov_Form_my 
   oQuery:Skip(1) 
Next 
oQuery:Destroy() 

Lov_Form_my.Lov_Grid_my.SetFocus 

RETURN 0 
*:***********************************************
FUNCTION year_start( )

   _dat = ctod('01.01.' + alltrim(str(year(date()))) )

RETURN _dat
*:***********************************************
FUNCTION year_end( )

   _dat = ctod('31.12.' + alltrim(str(year(date()))) )

RETURN _dat
*:***********************************************
* decimal sign define in Control Panel-International/Regional Setting
*************************************************
FUNCTION Decimal_sign( )

   _d = RegistryRead( "HKEY_CURRENT_USER\Control Panel\International\sDecimal" ) 

RETURN _d
*:***********************************************
* change decimal sign (if need)
*************************************************
FUNCTION StrDec ( _number )

   _StrRegional = alltrim(str(_number))

   if decimal_sign() != '.'
      _strRegional = strtran( _StrRegional, '.', decimal_sign() )
   endif

RETURN _StrRegional
